"use strict";

exports.__esModule = true;
exports.default = createD3TimeFormatter;

var _d3TimeFormat = require("d3-time-format");

var _core = require("@superset-ui/core");

var _TimeFormatter = _interopRequireDefault(require("../TimeFormatter"));

var _TimeFormats = require("../TimeFormats");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createD3TimeFormatter(config) {
  const {
    description,
    formatString = (0, _core.isRequired)('formatString'),
    label,
    locale,
    useLocalTime = false
  } = config;
  const id = useLocalTime ? "" + _TimeFormats.LOCAL_PREFIX + formatString : formatString;
  let formatFunc;

  if (typeof locale === 'undefined') {
    const format = useLocalTime ? _d3TimeFormat.timeFormat : _d3TimeFormat.utcFormat;
    formatFunc = format(formatString);
  } else {
    const localeObject = (0, _d3TimeFormat.timeFormatLocale)(locale);
    formatFunc = useLocalTime ? localeObject.format(formatString) : localeObject.utcFormat(formatString);
  }

  return new _TimeFormatter.default({
    description,
    formatFunc,
    id,
    label,
    useLocalTime
  });
}